#ifdef WIN32
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <SDL.h>

#define RX 800
#define RY 600
#define MAX_US 100
#define MENU "menu.bmp"

SDL_Surface *screen;			//hlavni
SDL_Surface *menu;				// menu
SDL_Surface *src,*dst;		//original, vysledek

bool ADD=true;		//pridat usecku??

int n=0;		//pocet zadanych car

struct BOD
{
	double x,y;
};

struct USECKA
{
	BOD P,Q;
};

struct VEKTOR
{
	double v1,v2;
};

USECKA U[MAX_US]; 

/////////////////////////////////////////////////////
//
//		POMOCNE FCE
//
/////////////////////////////////////////////////////
void Slock(SDL_Surface *screen)
{
  if ( SDL_MUSTLOCK(screen) ) {
    if ( SDL_LockSurface(screen) < 0 ) {
      return;
    }
  }
}

void Sulock(SDL_Surface *screen)
{
  if ( SDL_MUSTLOCK(screen) ) {
    SDL_UnlockSurface(screen);
  }
}

//	Vrati hodnoty RGB pro pixel
void GetColor(SDL_Surface *screen,int x, int y, Uint8 *R, Uint8 *G, Uint8 *B)
{
  Uint32 color;// = SDL_MapRGB(screen->format, R, G, B);
  switch (screen->format->BytesPerPixel) {
    case 1: // 8-bpp
      {
        Uint8 *bufp;
        bufp = (Uint8 *)screen->pixels + y*screen->pitch + x;
        color=*bufp;
      }
      break;
    case 2: // 15-bpp nebo 16-bpp
      {
        Uint16 *bufp;
        bufp = (Uint16 *)screen->pixels + y*screen->pitch/2 + x;
        color=*bufp;
      }
      break;
    case 3: // 24-bpp
      {
				Uint8 *bufp;
        bufp = (Uint8 *)screen->pixels + y*screen->pitch + x * 3;
        if(SDL_BYTEORDER == SDL_LIL_ENDIAN) {
          color=0;
					color = bufp[0] | (bufp[1]<<8) | (bufp[2]<<16);
        } else {
					color=0;
					color = bufp[2] & (bufp[1]<<8) & (bufp[0]<<16);
        }
      }
      break;
    case 4: // 32 bpp
      {
        Uint32 *bufp;
        bufp = (Uint32 *)screen->pixels + y*screen->pitch/4 + x;
        color=*bufp;
      }
      break;
  }
  SDL_GetRGB(color,screen->format,R,G,B);
}

//	vrati hodnoty RGB pro pixel zadany realnymi cisly s bilinearnim filtrem.
void GetColorBilinear(SDL_Surface *screen,double x,double y,Uint8 *r,Uint8 *g,Uint8 *b)
{
	Uint8 c_r[4],c_g[4],c_b[4]; //body v okoli (x,y);
	int ceil_x, ceil_y, floor_x, floor_y; //hodnoty x,y zaokrohleny dolu a nahoru
	Uint8 b1,b2;				//pomocne;

	if (x<0 || x>screen->w || y<0 || y>screen->h)  //pixel mimo dest;
	{
		*r=0;
		*g=0;
		*b=0;
		return;
	}

	floor_x=int(x);		//zaokrouhlovani
	floor_y=int(y);
	ceil_x=floor_x+1;
	ceil_y=floor_y+1;

	if (ceil_x > screen->w) ceil_x = floor_x;	//mimo obraz ne
  if (ceil_y > screen->h) ceil_y = floor_y;

	GetColor(screen,floor_x,floor_y,&(c_r[0]),&(c_g[0]),&(c_b[0]));		//barvy v okoli
	GetColor(screen,ceil_x,floor_y,&(c_r[1]),&(c_g[1]),&(c_b[1]));
	GetColor(screen,floor_x,ceil_y,&(c_r[2]),&(c_g[2]),&(c_b[2]));
	GetColor(screen,ceil_x,ceil_y,&(c_r[3]),&(c_g[3]),&(c_b[3]));

	// Blue
  b1 = (Uint8)((ceil_x-x)*c_b[0] + (x-floor_x)* c_b[1]);	//zapocitani barev
	b2 = (Uint8)((ceil_x-x)* c_b[2] + (x-floor_x)* c_b[3]);	//podle vzdalenosti k nejblizzsim
	*b = (Uint8)((ceil_y-y)* (double)(b1) + (y-floor_y) * (double)(b2));

	//green
	b1 = (Uint8)((ceil_x-x)*c_g[0] + (x-floor_x)* c_g[1]);
	b2 = (Uint8)((ceil_x-x)* c_g[2] + (x-floor_x)* c_g[3]);
	*g = (Uint8)((ceil_y-y)* (double)(b1) + (y-floor_y) * (double)(b2));

	//red
	b1 = (Uint8)((ceil_x-x)*c_r[0] + (x-floor_x)* c_r[1]);
	b2 = (Uint8)((ceil_x-x)* c_r[2] + (x-floor_x)* c_r[3]);
	*r = (Uint8)((ceil_y-y)* (double)(b1) + (y-floor_y) * (double)(b2));
}

/////////////////////////////////////////
// nakresli pixel
void DrawPixel(SDL_Surface *screen, int x, int y, Uint8 R, Uint8 G, Uint8 B)
{
  Uint32 color = SDL_MapRGB(screen->format, R, G, B);
  switch (screen->format->BytesPerPixel) {
    case 1: // Assuming 8-bpp
      {
        Uint8 *bufp;
        bufp = (Uint8 *)screen->pixels + y*screen->pitch + x;
        *bufp = color;
      }
      break;
    case 2: // Probably 15-bpp or 16-bpp
      {
        Uint16 *bufp;
        bufp = (Uint16 *)screen->pixels + y*screen->pitch/2 + x;
        *bufp = color;
      }
      break;
    case 3: // Slow 24-bpp mode, usually not used
      {
        Uint8 *bufp;
        bufp = (Uint8 *)screen->pixels + y*screen->pitch + x * 3;
        if(SDL_BYTEORDER == SDL_LIL_ENDIAN) {
          bufp[0] = color;
          bufp[1] = color >> 8;
          bufp[2] = color >> 16;
        } else {
          bufp[2] = color;
          bufp[1] = color >> 8;
          bufp[0] = color >> 16;
        }
      }
      break;
    case 4: // Probably 32-bpp
      {
        Uint32 *bufp;
        bufp = (Uint32 *)screen->pixels + y*screen->pitch/4 + x;
        *bufp = color;
      }
      break;
  }
}

// nacte obrazek;
bool NactiObr()
{
	char name[200];
	
	menu=SDL_LoadBMP(MENU);
	if (!menu) printf("error loading BMP\n");

	printf("Zadej jmeno souboru BMP (vcetne pripony): ");
	scanf("%s",name);
	src=SDL_LoadBMP(name);
	if (!src) printf("error loading BMP\n");
	return true;
}

//nakresli obrazek
void DrawIMG(SDL_Surface *img, int x, int y)
{
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_BlitSurface(img, NULL, screen, &dest);
}

////////////////////////////////////////////////
// cara
// invert znamena, barva pixelu bude inverze pozadi....
void line(SDL_Surface *screen,int x1,int y1,int x2,int y2,Uint8 r,Uint8 g,Uint8 b,bool invert)
{
	bool yLonger=false;
	int incrementVal;

	int shortLen=y2-y1;
	int longLen=x2-x1;
	if (abs(shortLen)>abs(longLen)) {
		int swap=shortLen;
		shortLen=longLen;
		longLen=swap;
		yLonger=true;
	}

	if (longLen<0) incrementVal=-1;
	else incrementVal=1;

	double divDiff;

	if (shortLen==0) divDiff=longLen;
	else divDiff=(double)longLen/(double)shortLen;

	if (yLonger) {
		for (int i=0;i!=longLen;i+=incrementVal) {
			if (invert) {
				GetColor(screen,x1+(int)((double)i/divDiff),y1+i,&r,&g,&b);
				r=255-r;
				g=255-g;
				b=255-b;
			}
			DrawPixel(screen,x1+(int)((double)i/divDiff),y1+i,r,g,b);
		}
	} else {
		
		for (int i=0;i!=longLen;i+=incrementVal) {
			if (invert) {
				GetColor(screen,x1+i,y1+(int)((double)i/divDiff),&r,&g,&b);
				r=255-r;
				g=255-g;
				b=255-b;
			}
			DrawPixel(screen,x1+i,y1+(int)((double)i/divDiff),r,g,b);
		}
	}
}


////////////////////////////////////////////////////////
//
// WARPING
//
////////////////////////////////////////////////////////
//
//	src - ukazatel na originalni obrazek
//	dest - ukazatel na vytvoreny obrazek
//	U - pole usecek
//	n - pocet usecek
//	p,b,a - parametry warpingu
void warping(SDL_Surface *src,SDL_Surface **dest,USECKA *U,int n,double P,double B,double A)
{
	double u,v,norma_pq,norma_pq1;

	int x,y;
	double x1,y1;
	Uint8 r,g,b;

	*dest=SDL_CreateRGBSurface(SDL_SWSURFACE,src->w,src->h,32,0,0,0,0);	//novy obrazek
	if (*dest==NULL) printf("error");

	for (x=0;x<src->w;x++)		// pro kazdy bod
	{
		for (y=0;y<src->h;y++)
		{
			double weightsum = 0;
			double DSUMx=0,DSUMy=0;

			for (int i=0;i<n;i=i+2)
			{
        VEKTOR PQ,PX,PQ_perp,PQ1,PQ1_perp;  //Potrebne vektory
				double Dx,Dy;
				double dist;
				double weight;

				PQ.v1 = U[i+1].Q.x-U[i+1].P.x;		//Vektor Mezi body Pi a Qi
				PQ.v2 = U[i+1].Q.y-U[i+1].P.y;

				PX.v1 = x-U[i+1].P.x;	//Vektor Mezi body X a Qi
				PX.v2 = y-U[i+1].P.y;

				PQ_perp.v1=-PQ.v2;		//Kolmy Vektor na PQ
				PQ_perp.v2=PQ.v1;

				PQ1.v1 = U[i].Q.x-U[i].P.x;	//Vektor Mezi body Pi' a Qi'
				PQ1.v2 = U[i].Q.y-U[i].P.y; 

				PQ1_perp.v1=-PQ1.v2;		//opet kolmy
				PQ1_perp.v2=PQ1.v1;

				norma_pq = sqrt(PQ.v1*PQ.v1+PQ.v2*PQ.v2);
				u=PX.v1*PQ.v1+PX.v2*PQ.v2;
				u=u/(norma_pq*norma_pq);

				v=PX.v1*PQ_perp.v1+PX.v2*PQ_perp.v2;
				v=v/(norma_pq);

				norma_pq1 = sqrt(PQ1.v1*PQ1.v1+PQ1.v2*PQ1.v2);
				x1 = U[i].P.x + u*PQ1.v1 + v*PQ1_perp.v1/norma_pq1;
				y1 = U[i].P.y + u*PQ1.v2 + v*PQ1_perp.v2/norma_pq1;

				Dx = x1-x;
				Dy = y1-y;

				if (u<0)		//vypocet dist
				{
					dist=sqrt(PX.v1*PX.v1+PX.v2*PX.v2);
				}
				else
				{
        	if (u<1)
						if (v>0) dist = v;
						else dist=-v;
					else
					{
						VEKTOR QX;
						QX.v1=U[i+1].Q.x-x;
						QX.v2=U[i+1].Q.y-y;
						dist=sqrt(QX.v1*QX.v1+QX.v2*QX.v2);
					}
				}
	
				weight = pow(pow(norma_pq,P)/(A+dist),B);
				DSUMx = DSUMx + weight*Dx;
				DSUMy = DSUMy + weight*Dy;
				weightsum = weightsum + weight;
			}

			x1=x+DSUMx/weightsum;
			y1=y+DSUMy/weightsum;

      GetColorBilinear(src,x1,y1,&r,&g,&b);	//barva s bilinearni interpolaci ze src
			DrawPixel(*dest,x,y,r,g,b);						//nakresli vysledny pixel do dest
		}
	}
}

void DrawScene(SDL_Surface *screen)
{
	if (ADD) DrawIMG(src,0,0);	//pokus pridavame usecky => zobrazen puvodni
  
	Slock(screen);
	for (int i=0;i<n;i++)			//zobrazeni car
	{
		line(screen,int(U[i].P.x),int(U[i].P.y),int(U[i].Q.x),int(U[i].Q.y),255,255,255,true);
	}
	Sulock(screen);

	if (!ADD) DrawIMG(dst,0,0);		//pokus nepridavame usecky => zobrazen vysledek
	DrawIMG(menu,RX-menu->w,0);	//postrani menu
  SDL_Flip(screen);
}




int main(int argc, char *argv[])
{

  /* Initialize the SDL library */
  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    printf("Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  printf("SDL initialized.\n");
  /* Clean up on exit */
  atexit(SDL_Quit);

  /*
   * Initialize the display in a 32-bit hardware supported mode
   */

	printf("*******************************************************\n\n");
	printf("Warping v1.0\n Petr Paus\n----------------------\n");
	printf("Program nacita pouze *.bmp\nSoubor menu.bmp musi byt ve stejnem adresari jako *.exe\n");
	printf("Ovladani:\nHned se zobrazi obrazek a program ceka na zadani prvniho\n");
	printf("paru usecek. Usecky se zadavaji tak, ze se stiskne mys (1. bod usecky)\n");
	printf("a tahne se mysi (pri stale stisklem levem tlacitku) na misto konce \n");
	printf("usecky. Uvolnenim tlacitka se ulozi 2. bod usecky\n");
	printf("Hned za sebou je treba zadat vzdy 2 usecky\n");
	printf("Dalsi par pridame pomoci butonu PRIDAT.\n");
	printf("Buton RESET vymaze zadane usecky a program rovnou ceka na zadani novych\n");;
	printf("Buton EXIT ukonci program :-)\n");
	printf("Doufam, ze je ten algoritmus spravne....\n\n");
	printf("pausp1@km1.fjfi.cvut.cz\n");
	printf("*******************************************************\n");

  NactiObr(); //nacteni obr.

  screen=SDL_SetVideoMode(RX,RY,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
  if ( screen == NULL ) {
    printf("Unable to set video: %s\n", SDL_GetError());
    exit(1);
  }
  printf("Set at %d bits-per-pixel mode\n", screen->format->BitsPerPixel);
  printf("Press Esc to quit\n");
  int done=0;

  /* Loop until an SDL_QUIT event is found or until we press Esc */
  while(done == 0) {
    SDL_Event event;

    /* Poll for events */
    while ( SDL_PollEvent(&event) )
    {
      if ( event.type == SDL_QUIT )  {  done = 1;  }
      if ( event.type == SDL_KEYDOWN ) {
        if ( event.key.keysym.sym == SDLK_ESCAPE ) { done = 1; }
      }
			if ( event.type == SDL_MOUSEBUTTONDOWN) //pridavame... stisk mysi pocatecni bod
			{
				if (ADD)			
				{
					U[n].P.x=event.button.x;
					U[n].P.y=event.button.y;
				}
			}

			if ( event.type == SDL_MOUSEBUTTONUP) //uvolneni mysi, koncovy bod
			{
				if (ADD)			
				{
					U[n].Q.x=event.button.x;
					U[n].Q.y=event.button.y;
					n++;
					if (n%2==0 && n>1)			//pokud jsou zadany 2 usecky, muzeme warpovat
					{
						warping(src,&dst,U,n,0.5,1,1);	//parametry  p=0.5,b=1,a=1;
						ADD=false;
					}
				}
				else
				{
					if (event.button.x>RX-100 && event.button.y<75)	//Tlacitko Pridat
					{
						ADD=true;
					}
				}
				if (event.button.x>RX-100 && event.button.y>150 && event.button.y<225)	//tlacitko reset
					{
						done=1;
					}
				if (event.button.x>RX-100 && event.button.y>75 && event.button.y<150)	//tlacitko exit
					{
						n=0;
						ADD=true;
					}
			}
    }

    DrawScene(screen);		//kreslime
  }

  return 0;
}
